## octave-optim 1.6.1

=== DESCRIPTION ===
Name: optim
Version: 1.6.1
Date: 2021-02-16
Author: various authors
Maintainer: Olaf Till <i7tiol@t-online.de>
Title: Optimization.
Description: Non-linear optimization toolkit.
Depends: octave (>= 4.0.0), struct (>= 1.0.12), statistics (>= 1.4.0)
Autoload: no
License: GPLv3+, modified BSD, public domain

=== Makefile ===
## Copyright 2015-2016 Carnë Draug
## Copyright 2015-2016 Oliver Heimlich
## Copyright 2017 Julien Bect <jbect@users.sf.net>
## Copyright 2017 Olaf Till <i7tiol@t-online.de>
##
## Copying and distribution of this file, with or without modification,
## are permitted in any medium without royalty provided the copyright
## notice and this notice are preserved.  This file is offered as-is,
## without any warranty.

## Some basic tools (can be overriden using environment variables)
SED ?= sed
TAR ?= tar
GREP ?= grep
CUT ?= cut
TR ?= tr

## Note the use of ':=' (immediate set) and not just '=' (lazy set).
## http://stackoverflow.com/a/448939/1609556
package := $(shell $(GREP) "^Name: " DESCRIPTION | $(CUT) -f2 -d" " | \
$(TR) '[:upper:]' '[:lower:]')
version := $(shell $(GREP) "^Version: " DESCRIPTION | $(CUT) -f2 -d" ")

## These are the paths that will be created for the releases.
target_dir       := target
release_dir      := $(target_dir)/$(package)-$(version)
release_tarball  := $(target_dir)/$(package)-$(version).tar.gz
html_dir         := $(target_dir)/$(package)-html
html_tarball     := $(target_dir)/$(package)-html.tar.gz
## Using $(realpath ...) avoids problems with symlinks due to bug
## #50994 in Octaves scripts/pkg/private/install.m.  But at least the
## release directory above is needed in the relative form, for 'git
## archive --format=tar --prefix=$(release_dir).
real_target_dir  := $(realpath .)/$(target_dir)
installation_dir := $(real_target_dir)/.installation
package_list     := $(installation_dir)/.octave_packages
install_stamp    := $(installation_dir)/.install_stamp

## These can be set by environment variables which allow to easily
## test with different Octave versions.
ifndef OCTAVE
OCTAVE := octave
endif
OCTAVE := $(OCTAVE) --no-gui --silent --norc
MKOCTFILE ?= mkoctfile

## Command used to set permissions before creating tarballs
FIX_PERMISSIONS ?= chmod -R a+rX,u+w,go-w,ug-s

## Detect which VCS is used
vcs := $(if $(wildcard .hg),hg,$(if $(wildcard .git),git,unknown))
ifeq ($(vcs),hg)
release_dir_dep := .hg/dirstate
endif
ifeq ($(vcs),git)
release_dir_dep := .git/index
endif


## .PHONY indicates targets that are not filenames
## (https://www.gnu.org/software/make/manual/html_node/Phony-Targets.html)
.PHONY: help

## make will display the command before runnning them.  Use @command
## to not display it (makes specially sense for echo).
help:
	@echo "Targets:"
	@echo "   dist    - Create $(release_tarball) for release."
	@echo "   html    - Create $(html_tarball) for release."
	@echo "   release - Create both of the above and show md5sums."
	@echo "   install - Install the package in $(installation_dir), where it is not visible in a normal Octave session."
	@echo "   check   - Execute package tests."
	@echo "   doctest - Test the help texts with the doctest package."
	@echo "   run     - Run Octave with the package installed in $(installation_dir) in the path."
	@echo "   clean   - Remove everything made with this Makefile."


##
## Recipes for release tarballs (package + html)
##

.PHONY: release dist html clean-tarballs clean-unpacked-release

## To make a release, build the distribution and html tarballs.
release: dist html
	md5sum $(release_tarball) $(html_tarball)
	@echo "Upload @ https://sourceforge.net/p/octave/package-releases/new/"
	@echo "    and note the changeset the release corresponds to"

## dist and html targets are only PHONY/alias targets to the release
## and html tarballs.
dist: $(release_tarball)
html: $(html_tarball)

## An implicit rule with a recipe to build the tarballs correctly.
%.tar.gz: %
	$(TAR) -c -f - --posix -C "$(target_dir)/" "$(notdir $<)" | gzip -9n > "$@"

clean-tarballs:
	@echo "## Cleaning release tarballs (package + html)..."
	-$(RM) $(release_tarball) $(html_tarball)
	@echo

## Create the unpacked package.
##
## Notes:
##    * having ".hg/dirstate" (or ".git/index") as a prerequesite means it is
##      only rebuilt if we are at a different commit.
##    * the variable RM usually defaults to "rm -f"
##    * having this recipe separate from the one that makes the tarball
##      makes it easy to have packages in alternative formats (such as zip)
##    * note that if a commands needs to be run in a specific directory,
##      the command to "cd" needs to be on the same line.  Each line restores
##      the original working directory.
$(release_dir): $(release_dir_dep)
	-$(RM) -r "$@"
ifeq (${vcs},hg)
	hg archive --exclude ".hg*" --type files "$@"
endif
ifeq (${vcs},git)
	git archive --format=tar --prefix="$@/" HEAD | $(TAR) -x
	$(RM) "$@/.gitignore"
endif
## Don't fall back to run the supposed necessary contents of
## 'bootstrap' here. Users are better off if they provide
## 'bootstrap'. Administrators, checking build reproducibility, can
## put in the missing 'bootstrap' file if they feel they know its
## necessary contents.
ifneq (,$(wildcard src/bootstrap))
	cd "$@/src" && ./bootstrap && $(RM) -r "autom4te.cache"
endif
## Uncomment this if your src/Makefile.in has these targets for
## pre-building something for the release (e.g. documentation).
	cd "$@/src" && ./configure && $(MAKE) prebuild && \
	  $(MAKE) distclean && $(RM) Makefile
##
	${FIX_PERMISSIONS} "$@"

run_in_place = $(OCTAVE) --eval ' pkg ("local_list", "$(package_list)"); ' \
                         --eval ' pkg ("load", "$(package)"); '

# html_options = --eval 'options = get_html_options ("octave-forge");'
## Uncomment this for package documentation.
html_options = --eval 'options = get_html_options ("octave-forge");' \
               --eval 'options.package_doc = "$(package).texi";'
$(html_dir): $(install_stamp)
	$(RM) -r "$@";
	$(run_in_place)                    \
        --eval ' pkg load generate_html; ' \
	$(html_options)                    \
        --eval ' generate_package_html ("$(package)", "$@", options); ';
	$(FIX_PERMISSIONS) "$@";

clean-unpacked-release:
	@echo "## Cleaning unpacked release tarballs (package + html)..."
	-$(RM) -r $(release_dir) $(html_dir)
	@echo

##
## Recipes for installing the package.
##

.PHONY: install clean-install

octave_install_commands = \
' llist_path = pkg ("local_list"); \
  mkdir ("$(installation_dir)"); \
  load (llist_path); \
  local_packages(cellfun (@ (x) strcmp ("$(package)", x.name), local_packages)) = []; \
  save ("$(package_list)", "local_packages"); \
  pkg ("local_list", "$(package_list)"); \
  pkg ("prefix", "$(installation_dir)", "$(installation_dir)"); \
  pkg ("install", "-local", "-verbose", "$(release_tarball)"); '

## Install unconditionally. Maybe useful for testing installation with
## different versions of Octave.
install: $(release_tarball)
	@echo "Installing package under $(installation_dir) ..."
	$(OCTAVE) --eval $(octave_install_commands)
	touch $(install_stamp)

## Install only if installation (under target/...) is not current.
$(install_stamp): $(release_tarball)
	@echo "Installing package under $(installation_dir) ..."
	$(OCTAVE) --eval $(octave_install_commands)
	touch $(install_stamp)

clean-install:
	@echo "## Cleaning installation under $(installation_dir) ..."
	-$(RM) -r $(installation_dir)
	@echo


##
## Recipes for testing purposes
##

.PHONY: run doctest check

## Start an Octave session with the package directories on the path for
## interactice test of development sources.
run: $(install_stamp)
	$(run_in_place) --persist

## Test example blocks in the documentation.  Needs doctest package
##  https://octave.sourceforge.io/doctest/index.html
doctest: $(install_stamp)
	$(run_in_place) --eval 'pkg load doctest;'                                                          \
	  --eval "targets = '$(shell (ls inst; ls src | $(GREP) .oct) | $(CUT) -f2 -d@ | $(CUT) -f1 -d.)';" \
	  --eval "targets = strsplit (targets, ' ');  doctest (targets);"


## Test package.
octave_test_commands = \
' args = {"inst", "src"}; \
  function ret = nodir (x) \
    ret = isempty (a = stat (x)) || ! S_ISDIR (a.mode); \
  endfunction; \
  args(cellfun (@ (x) nodir (x), args)) = []; \
  if (isempty (args)) error ("no \"inst\" or \"src\" directory"); exit (1); \
    else cellfun(@runtests, args); endif '
check: $(install_stamp)
	$(run_in_place) --eval $(octave_test_commands)


##
## CLEAN
##

.PHONY: clean

clean: clean-tarballs clean-unpacked-release clean-install
	@echo "## Removing target directory (if empty)..."
	-rmdir $(target_dir)
	@echo
	@echo "## Cleaning done"
	@echo

=== debian/changelog ===
octave-optim (1.6.1-2build1) jammy; urgency=medium

  * No-change rebuild against octave 6.4.0

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 19 Jan 2022 12:50:48 +0000

octave-optim (1.6.1-2) unstable; urgency=medium

  * Upload to unstable
  * d/rules: Use execute_after_dh_auto_install instead of
    override_dh_auto_install

 -- Rafael Laboissière <rafael@debian.org>  Sun, 15 Aug 2021 18:29:18 -0300

octave-optim (1.6.1-1) experimental; urgency=medium

  * New upstream version 1.6.1
  * d/p/octave6.patch: Drop patch (applied upstream)
  * d/copyright: Reflect upstream changes

 -- Rafael Laboissière <rafael@debian.org>  Sat, 20 Feb 2021 02:48:07 -0300

=== debian/control ===
Source: octave-optim
Section: math
Priority: optional
Maintainer: Debian Octave Group <team+pkg-octave-team@tracker.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>,
           Rafael Laboissière <rafael@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-octave (>= 0.7.1),
               texlive,
               ghostscript,
               octave-struct,
               octave-statistics
Standards-Version: 4.5.1
Homepage: https://octave.sourceforge.io/optim/
Vcs-Git: https://salsa.debian.org/pkg-octave-team/octave-optim.git
Vcs-Browser: https://salsa.debian.org/pkg-octave-team/octave-optim
Testsuite: autopkgtest-pkg-octave
Rules-Requires-Root: no

Package: octave-optim
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${octave:Depends}
Suggests: octave-parallel
Multi-Arch: same
Description: unconstrained non-linear optimization toolkit for Octave
 Unconstrained Non-linear Optimization toolkit for Octave, a numerical
 computation software. Included are functions to do linear least
 square fitting on data points, nonlinear regression using the
 Levenberg-Marquardt algorithm, Prony's method for non-linear exponent
 fitting and many more.
 .
 This Octave add-on package is part of the Octave-Forge project.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@ --buildsystem=octave --with=octave

# Recompile the info file (it has been cleaned by the pkg install), and then
# install it in the system-wide directory (after renaming it).
execute_after_dh_auto_install:
	( cd src ; ./configure ; make doc )
	mkdir -p debian/octave-optim/usr/share/info/
	cp doc/optim.info debian/octave-optim/usr/share/info/octave-optim.info

## octave-optim 1.6.2~20220410.hg83eefe9

=== debian/changelog ===
octave-optim (1.6.2~20220410.hg83eefe9-1) unstable; urgency=medium

  [ Rafael Laboissière ]
  * d/copyright: Accentuate my family name
  * d/control: Bump Standards-Version to 4.6.0 (no changes needed)
  * Set upstream metadata fields: Archive.

  [ Sébastien Villemot ]
  * New upstream mercurial snapshot
    + fixes FTBFS against Octave 7 (Closes: #1009139)
  * d/copyright: reflect upstream changes

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 12 Apr 2022 16:44:20 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                ghostscript,
                octave-struct,
                octave-statistics
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://octave.sourceforge.io/optim/
 Vcs-Git: https://salsa.debian.org/pkg-octave-team/octave-optim.git
 Vcs-Browser: https://salsa.debian.org/pkg-octave-team/octave-optim

## octave-optim 1.6.2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Name: optim
-Version: 1.6.1
-Date: 2021-02-16
+Version: 1.6.2
+Date: 2022-04-10
 Author: various authors
 Maintainer: Olaf Till <i7tiol@t-online.de>
 Title: Optimization.

=== Makefile ===
--- 
+++ 
@@ -165,8 +165,12 @@
 octave_install_commands = \
 ' llist_path = pkg ("local_list"); \
   mkdir ("$(installation_dir)"); \
-  load (llist_path); \
-  local_packages(cellfun (@ (x) strcmp ("$(package)", x.name), local_packages)) = []; \
+  if (isempty (stat (llist_path))) \
+    local_packages = cell (1, 0); \
+  else \
+    load (llist_path); \
+    local_packages(cellfun (@ (x) strcmp ("$(package)", x.name), local_packages)) = []; \
+  endif; \
   save ("$(package_list)", "local_packages"); \
   pkg ("local_list", "$(package_list)"); \
   pkg ("prefix", "$(installation_dir)", "$(installation_dir)"); \

=== debian/changelog ===
octave-optim (1.6.2-5) unstable; urgency=medium

  * d/control:
    + Replace build-dependency octave-statistics by
      octave-statistics-common
    + Exclude build-dependencies octave-statistics-common and
      octave-struct when profile nocheck is active
  * d/watch: Convert to format version 5
  * d/s/lintian-override: Override Lintian warning
    debian-watch-lacks-sourceforge-redirector
  * d/clean: New file
  * Proper installation of .info file
    + d/octave-optim.info: New file
    + d/rules: Change name of info file at the build directory
      directory.
  * d/octave-optim.docs: Also install the doc/development/ directory
  * d/rules: Build the documentation in HTML format

 -- Rafael Laboissière <rafael@debian.org>  Thu, 02 Oct 2025 00:59:49 -0300

octave-optim (1.6.2-4) unstable; urgency=medium

  [ Rafael Laboissière ]
  * d/control: Update Homepage URL
  * d/copyright: Update Source URL
  * d/u/metadata: Update Bug-Database URL
  * d/u/metadata: Add upstream repository URL
  * d/u/metadata: Add Documentation URL
  * d/control: Bump Standards-Version to 4.7.2 (no changes needed)
  * d/control: Drop the versioned dependency on dh-octave.
    Relationship >= 1.2.3 is satisfiable in oldoldstable, which has version
    1.2.7.

  [ Sébastien Villemot ]
  * Drop “Rules-Requires-Root: no”, which is now the default
  * octave10.patch: new patch, fixes FTBFS against Octave 10 (Closes: #1101763)

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 26 Aug 2025 22:42:14 +0200

octave-optim (1.6.2-3) unstable; urgency=medium

  * d/watch: Adjust for new URL at gnu-octave.github.io
  * d/s/lintian-override: Override Lintian warning
    debian-watch-lacks-sourceforge-redirector
  * d/copyright: Update Copyright years for debian/* files

 -- Rafael Laboissière <rafael@debian.org>  Mon, 05 Dec 2022 10:37:36 -0300

octave-optim (1.6.2-2) unstable; urgency=medium

  * d/control: Bump Standards-Version to 4.6.1 (no changes needed)
  * Build-depend on dh-sequence-octave
    + d/control: Ditto
    + d/rules: Drop the --with=octave option from dh call
  * Proper cleaning of files generated by the configure script
    + d/clean: Drop obsolete file
    + d/p/remove-Makefile-in-distclean-rule.patch: New patch
    + d/control: Build-depend on dh-octave >= 1.2.3
  * d/s/lintian-overrides: New file for ignoring source-is-missing errors

 -- Rafael Laboissière <rafael@debian.org>  Wed, 13 Jul 2022 17:55:44 -0300

octave-optim (1.6.2-1) unstable; urgency=medium

  * New upstream version 1.6.2
  * octave7.patch: new patch taken from upstream; further Octave 7 fix

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 15 Apr 2022 11:29:37 +0200

=== debian/control ===
--- 
+++ 
@@ -5,17 +5,14 @@
 Uploaders: Sébastien Villemot <sebastien@debian.org>,
            Rafael Laboissière <rafael@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               dh-octave (>= 0.7.1),
-               texlive,
-               ghostscript,
-               octave-struct,
-               octave-statistics
-Standards-Version: 4.6.0
-Homepage: https://octave.sourceforge.io/optim/
+               dh-sequence-octave,
+               octave-statistics-common <!nocheck>,
+               octave-struct <!nocheck>
+Standards-Version: 4.7.2
+Homepage: https://gnu-octave.github.io/packages/optim/
 Vcs-Git: https://salsa.debian.org/pkg-octave-team/octave-optim.git
 Vcs-Browser: https://salsa.debian.org/pkg-octave-team/octave-optim
 Testsuite: autopkgtest-pkg-octave
-Rules-Requires-Root: no
 
 Package: octave-optim
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@ --buildsystem=octave

# Recompile the info file (it has been cleaned by the pkg install), and then
# install it in the system-wide directory (after renaming it).
execute_after_dh_auto_install:
	( cd src ; make html )
	mv doc/optim.info doc/octave-optim.info

=== debian/watch ===
Version: 5

Source: https://gnu-octave.github.io/packages/optim/
Matching-Pattern: https://downloads.sourceforge.net/project/octave/Octave%20Forge%20Packages/Individual%20Package%20Releases/optim-@ANY_VERSION@@ARCHIVE_EXT@
